private string myname,dirdesc;
private object me,thisob,watcher_ob;
private int op_dir,obscure;

/* cast detect invisible
        teleport to <player>
	locate <player>
	light
	diagnoze <player/monster>
	dig <direction>
	obscure
	summon watcher spirit   
	whisper spirit         */




/********** standard local fns ***********/

reset(arg) {
  if(arg) return;
  me=this_player();
  myname=capitalize(me->query_name());
  thisob=this_object();
  dirdesc=({"north","south","east","west","up" ,"down"});
  op_dir=({2,1,4,3,6,5});
  obscure=0;
}

get() { return 1; }
drop() { return 1; }

long() {
  write("Spell-test object\n");
}

id(str) {
  return str=="magobj";
}

init() {
  add_action("cast","cast");
}


/********************/
/****** spells ******/
/********************/

cast(str) {
  int result;
  string spell,args;

  if(!str) return 0;
  if(sscanf(str,"%s %s",spell,args)!=2) spell=str;
  
  result=call_other(thisob,spell,args);

  if(result==1) return 1;               /* ok */
  
  if(result==2 || result==0) {          /* syntax error */
    notify_fail("You know no such spell.\n");
    return 0;
  }

  if(result==3) {                       /* too low level */
    write("You feel much too inexperienced to try this powerful spell.\n");
    return 1;
  }
  
  if(result==4) {                       /* too low spellp */
    write("Alas, you are too weak! You cannot concentrate enough!\n");
    say(myname+" mumbles a few words, but "+
	me->query_possessive()+" spell fails.\n");
    say(myname+" looks very tired.\n");
    return 1;
  }
  write("Error: unknown return code\n");
  return 1;
}

/********** detect invisible ***********/

detect(args) {
  string arg2;
  if(args=="invisible") {
    if(!chk_lvl(11)) return 3;
    if(!chk_sp(10)) return 4;
    detect_invis();
    drain_sp(10);
    return 1;
  }
}

detect_invis() {
  object ob;
  int found;
  found=0;
  ob=first_inventory(environment(me));
  while(ob) {
    if(ob->query_name()=="Someone") {

      write("You can see the silhouette of "+
	    capitalize(ob->query_real_name())+ " "+
	    ob->query_title()+"\n");
      found=1;
    }
    ob=next_inventory(ob);
  }
  if(found) {
    say(myname+
     " is concentrating hard and seems to be staring at\n"+
     "something in this room invisible for your eyes.\n");
  }
  else {
    write("You find nothing.\n");
  }
}


/*********** teleport to <player> ************/

teleport(args) {
  object who;
  string arg1,from_realm,dest_realm;

  if(!args) return 0;
  if(args=="to") {
    write("Teleport to whom?\n");
    return 1;
  }
  if(sscanf(args,"to %s",arg1)!=1) return 0;

  if(!chk_lvl(19)) return 3;
  if(!chk_sp(100)) return 4;

  who=find_living(arg1);

  if(!who || !query_ip_number(who)) {
    write("There is no person with that name.\n");
    return 1;
  }

  if(who->query_level()>19) {
    write("Your spell fails! That players magic is too strong for you.\n");
    say(myname+"'s contours begin to shimmer, but "+
	me->query_possessive()+" spell fails.\n");
    tell_object(who,myname+" tried to teleport to you.\n");
    drain_sp(20);
    return 1;
  }

  from_realm=environment(this_player())->realm();
  dest_realm=environment(who)->realm();

  if((from_realm != dest_realm) || (from_realm == "NT")) {
    write("Your spell fails! Something prevents you from\n"+
	  "teleporting to that place.\n");
    say(myname+"'s contours begin to shimmer, but "+
	me->query_possessive()+" spell fails.\n");
    drain_sp(20);
    return 1;
  }

  if(present("drk2",me)) {    /*  nope */
    write("Alas, your spell fails! It probably has something to do\n"+
	  "with the bottles you are carrying.\n");
    say(myname+"'s contours begin to shimmer, but "+
	me->query_possessive()+" spell fails.\n");
    drain_sp(20);
    return 1;
  }

  if(present("obscure_ob",who)) {
    write("Your spell fails! That player is magically protected");
    write(" against teleport spells.\n");
    say(myname+"'s contours begin to shimmer, but "+
	me->query_possessive()+" spell fails.\n");
    tell_object(who,myname+" tried to teleport to you.\n");
    drain_sp(20);
    return 1;
  }

  /* Everything ok. Move. */

  say(myname+" begins to chant a powerfull spell. The air around "+
      me->query_possessive()+" begins to glow.\n");
  me->move_player("into another dimension",environment(who));
  drain_sp(100);
  return 1;
}



/*************** locate <player/monster> ***************/

locate(arg) {
  object whom;

  if(!arg) return 0;
  if(!chk_lvl(13)) return 3;
  if(!chk_sp(20)) return 4;
  
  whom=find_living(arg);

  say(myname+" puts his fingers to his forehead and concentrates hard.\n");

  if(!whom) {
    write("You concentrate hard, but can only see darkness.\n");
    drain_sp(20);
    return 1;
  }

  if(present("obscure_ob",whom)) {
    write("Your spell fails! That player is magically protected");
    write(" against locate spells.\n");
    tell_object(whom,myname+" tried to locate you.\n");
    drain_sp(20);
    return 1;
  }
  
  write("You concentrate hard and can see: "+
	environment(whom)->short()+"\n");
  drain_sp(20);
  return 1;
}



/************** light **************/

light() {
  object lightob;
  if(!chk_lvl(3)) return 3;
  if(!chk_sp(20)) return 4;

  lightob=clone_object("players/angmar/spells/light_ob");
  move_object(lightob,me);
  lightob->init_dest();
  say(myname+" mumbles something and makes a gesture.\n");
  write("Ok.\n");
  drain_sp(20);
  if(lightob->test_dark()) {
    write("You can see again!\n");
    say("You can see again!\n");
  }
  return 1;
}


/************* diagnose *************/

diagnose(arg) {
  object whom;
  int maxhp,curhp;
  string whonam;
  
  if(!chk_lvl(7)) return 3;
  if(!chk_sp(5)) return 4;

  if(!arg) {
    write("Diagnose whom?\n");
    return 1;
  }
  
  whom=find_living(arg);

  if(!whom) {
    write("There is no such creature or person.\n");
    return 1;
  }

  whonam=capitalize(arg);

  maxhp=whom->query_max_hp();
  curhp=whom->query_hp();

  drain_sp(5);
  say(myname+" mumbles a spell.\n");

  if (curhp < maxhp/10) {
    write(whonam + " is in very bad shape.\n");
    return 1;
  }
  if (curhp < maxhp/5) {
    write(whonam + " is in bad shape.\n");
    return 1;
  }
  if (curhp < maxhp/2) {
    write(whonam + " is not in a good shape.\n");
    return 1;
  }
  if (curhp < maxhp - maxhp/5) {
    write(whonam + " is slightly hurt.\n");
    return 1;
  }
  write(whonam + " is in good shape.\n");
  
  return 1;
}


/************* dig <direction> **********/

dig(dir) {
  int dirnr,depth;
  object env,newroom,newroom2;

  if(!chk_lvl(17)) return 3;
  if(!chk_sp(5)) return 4;

  dirnr=0;

  if(dir=="n" || dir=="north") dirnr=1;
  if(dir=="s" || dir=="south") dirnr=2;
  if(dir=="e" || dir=="east") dirnr=3;
  if(dir=="w" || dir=="west") dirnr=4;
  if(dir=="u" || dir=="up") dirnr=5;
  if(dir=="d" || dir=="down") dirnr=6;

  if(environment(me)->query_inorout()==1) {
    write("You can't dig in here!\n");
    return 1;
  }


  if(dirnr==0) {
    write("Dig in what direction?\n");
    return 1;
  }

  if(dirnr==6 && depth==0 && downp()) {
    write("You can't dig that way!\n");
    return 1;
  }

  env=environment(me);
  depth=env->query_depth();

  if(depth==0 && dirnr!=6) {
    write("You can only dig down from here.\n");
    return 1;
  }

  if(depth==1 && dirnr==5) {
    write("You dare not dig up from here. The ceiling of the tunnel\n"+
	  "might fall down on you.\n");
    return 1;
  }

  newroom=clone_object("players/angmar/spells/underground");

  if((depth !=0 && !env->add_room(dirnr,newroom)) ||
     (depth == 0) && present("underground",env)) {
    write("You can't dig that way!\n");
    destruct(newroom);
    return 1;
  }

  if(depth==0) {
    newroom->set_short("There is a hole going down here");
    newroom->enlighten();
    newroom2=clone_object("players/angmar/spells/underground");
    newroom2->set_depth(1);
    newroom2->set_short("In a tunnel");
    newroom2->enlighten();
    newroom2->add_room(5,env);
    newroom->add_room(6,newroom2);
    move_object(newroom,env);
  }
  else {
    if(dirnr==5) depth-=1;
    if(dirnr==6) depth+=1;
    newroom->set_short("In a tunnel");
    newroom->set_depth(depth);
    newroom->add_room(op_dir[dirnr-1],env);
  }
  say(myname+" summons a fire elemental and burns a hole "+
	dirdesc[dirnr-1]+".\n");
  write("You summon a fire elemental and burn a hole "+
	dirdesc[dirnr-1]+".\n");

  drain_sp(5);
  return 1;
}

/********** summon watcher spirit ***********/

summon(args) {
  string arg2;
  if(args=="watcher spirit") {
    if(!chk_lvl(16)) return 3;
    if(!chk_sp(40)) return 4;
    if(watcher_ob) {
      write("But you already have a watcher spirit!\n");
      return 1;
    }
    summon_watcher();
    drain_sp(40);
    return 1;
  }
}

summon_watcher() {
  say(myname+" summons a Watcher spirit\n");
  write("You summon a Watcher spirit\n");
  watcher_ob=clone_object("/players/angmar/spells/watcher");
  move_object(watcher_ob,environment(me));
  watcher_ob->set_return_ob(me);
  watcher_ob->init_dest();
}




/*********** whisper spirit ************/

whisper(args) {
  object who,envroom;
  string arg1;


  if(!args) return 0;

  arg1=args;

  if(!chk_lvl(18)) return 3;
  if(!chk_sp(5)) return 4;

  if(!watcher_ob) {
    write("But you have no watcher spirit!\n");
    return 1;
  }

  say(myname+" mutters something to "+me->query_objective()+"self.\n");

  envroom=environment(me);
/*  watcher_ob->set_return_ob(0); */
/*  move_object(me,environment(watcher_ob)); */
/*  say("The watcher spirit whispers: "+arg1+"\n"); */
/*  move_object(me,envroom); */
/*   watcher_ob->set_return(me); */
  command("whisper "+arg1,watcher_ob);
  write("Ok.\n");
  drain_sp(5);
  return 1;
}



/************** obscure **************/

obscure() {
  object obscureob;

  if(!chk_sp(5)) return 4;

  obscureob=clone_object("players/angmar/spells/obscure_ob");
  move_object(obscureob,me);
  obscureob->init_dest();
  say(myname+
" mutters something and makes strange signs in the air with his finger.\n");
  write("Ok.\n");
  drain_sp(5);
  write("You are now protected against teleport and location spells.\n");
  return 1;
}

/****** helpfns ******/

chk_lvl(lvl) {
  return me->query_level()>=lvl;
}

chk_sp(sp) {
  return me->query_spell_points()>=sp;
}

drain_sp(sp) {
  me->restore_spell_points(-sp);
}  

/* check if down is already defined */
downp() {
  object dtester,remroom,destroom;
  dtester=clone_object("players/angmar/spells/dtester");
  remroom=environment(me);
  move_object(dtester,remroom);
  command("d",dtester);
  destroom=environment(dtester);
  destruct(dtester);
  if(remroom!=destroom) return 1;
}
