string shortdesc,nrdesc,dirdesc;
int dirs,depth,nrxt,ind,nr,pow;
object nroom;

/* 1  north
   2  south
   4  east
   8  west
   16 up
   32 down   */

reset(arg) { 
  if(arg) return;
  set_light(0);
  nrxt=0;
  dirs=0;
  nrdesc=({"one","two","three","four","five","six"});
  dirdesc=({" north"," south"," east"," west"," up" ," down"});
  pow=({1,1,2,4,8,16,32});
  if(!nroom) nroom=allocate(6);
}

set_short(str) { shortdesc=str; }
query_depth() { return depth; }
set_depth(xx) { depth=xx; }
enlighten() { set_light(1); }

id(str) { return str=="underground" || str=="hole"; }

short() {
  if(set_light(0)==0) return "dark room";
  return shortdesc;
}

long(str) {

  if(str=="hole") {
    write("Looks like it's possible to enter it.\n");
    return;
  }

  if(str) return;

  if(set_light(0)==0) {
    write("It is dark.\n");
    return;
  }

  write("Someone has dug a tunnel here.\n");
  if(nrxt==1) write("There is one obvious exit: ");
  else write("There are "+nrdesc[nrxt-1]+" obvious exits:\n     ");

  nr=0; ind=1;
  while(ind<=6) {
    if(dirs & pow[ind]) {
      nr+=1;
      if(nr==nrxt && nrxt>1) write(" and");
      write(dirdesc[ind-1]);
    }
    ind+=1;
  }
  write(".\n");
}

init() {
  if(dirs & 1) add_action("moven","north");
  if(dirs & 2) add_action("moves","south");
  if(dirs & 4) add_action("movee","east");
  if(dirs & 8) add_action("movew","west");
  if(dirs & 16) add_action("moveu","up");
  if(dirs & 32) add_action("moved","down");
}

moven() { this_player()->move_player("north",nroom[0]); return 1; }
moves() { this_player()->move_player("south",nroom[1]); return 1; }
movee() { this_player()->move_player("east",nroom[2]); return 1; }
movew() { this_player()->move_player("west",nroom[3]); return 1; }
moveu() { this_player()->move_player("up",nroom[4]); return 1; }
moved() { this_player()->move_player("down",nroom[5]); return 1; }

add_room(dir,ob) { 
  if(dirs & pow[dir]) return 0;
  dirs|=pow[dir];
  nrxt+=1;
  nroom[dir-1]=ob;
  fix_init();
 return 1;
}

fix_init() {
  object ob, next_ob;
  ob=first_inventory(this_object());
  while(ob) {
    next_ob=next_inventory(ob);
    move_object(ob,this_object());
    ob=next_ob;
  }
}
